--[[
	平台管理
]]
PlatformMgr = PlatformMgr or {
	network = 1, 			--当前网络类型: 0-无，1-wifi，2-2G, 3-3G, 4-4G 5-Mobile
	phoneModel = "windows",	--手机型号
	deviceId = "unkown",	--设备id
	batterPercent = 100,	--电量百分比值
	isOpenAlert = false,	--是否打开了android alert信息窗
	isPauseGuide = false,	--是否暂停引导，后台回来不主动恢复
	isAppEnterBackground = false,
	timstamp = os.time(),	--进入后台时的时间戳

	url_update = "",		--资源更新检查地址
	url_session = "",		--session验证地址
	url_servers = "",		-- 服务器列表地址
	url_activity = "",		--列表地址
	url_announcement = "",	--公告地址
	url_build_order = "",	--生成订单
	url_broadcast = "",		--广播地址
	url_iappurchase = "",	--iap(苹果内购)的同步url
	url_pay_syn	= "",		--通用的支付同步url
	url_bind_wechat = "",	--游客账号绑定微信url
	url_user_login = "",	--玩家登陆
	url_register = "",		--玩家注册
	url_change_passwd = "",	--修改密码
	url_get_login_type= "", --获取登录类型
	
	
	--支付
	payHandler= nil,
	tClientOrders = {		--客户端支付订单列表
	--[[
		cpOrderNo = result	--cp订单id，result-0未有服务响应结果 1-有服务端响应结果
	]]
	},
	tServerOrders = {},		--服务端支付结果的订单列表
	tTempSvrOrder = {},		--所有完成的服务端订单：掌娱支付完成心跳返回结果快，支付界面返回游戏慢的话会重新请求支付结果，就有问题
	isOnPayReq = false, 	--是否正在请求支付结果
	
	tIAPOrders = {			--苹果支付订单
	--[[
		cpOrderNo = {receipt=, reqCount=}
	]]
	},
	
	domainIdx = 0,
	http_domains = "lyx.ptwan.com", 	--三国英雄传
	-- http_domains = "n.m.99yx.com"	--appstore 霸三
	
}

local this = PlatformMgr

this.blacklist = { --域名解析的黑名单
	httpserver = {},
	gameserver = {},
}		

--[[
	获取渠道标识
]]
function PlatformMgr.getChannel()
	local channel = 6000
	
	if device.platform == "android" then
		-- call Java method
		local javaClassName = "com/common/mir/MirNative"
		local javaMethodName = "getChannel"
		local javaParams = {}
		local javaMethodSig = "()I"
		
		local ret, result = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
		
		if ret then channel = result end
	elseif device.platform=="ios" then
		channel = CCPlatformMgr:getInstance():getChannel()
	end
	
	return channel
end

--渠道账号信息
ChannelUserInfo = ChannelUserInfo or NObject:new(
--[[
{
	session =,	string  sdk session
	uid		=,	string  渠道uid
	pid		=,	integer 渠道id
	userType=,	integer 用户类型：0|nil-正式用户(通过渠道sdk登录) 1-游客(ios appstore 无微信用户登录)
}
]]
)

if not ChannelUserInfo:Get("uid") then
	ChannelUserInfo:Set("uid", 0)
	ChannelUserInfo:Set("pid", this.getChannel())
end

--[[
	设置web访问的地址
]]
function PlatformMgr.setWebUrl(host)
	--改成其他游戏: 资源更新/session验证
	-- this.url_update = string.format("http://%s/api/versionbs", host)		--(霸三)资源更新检查地址: serverid/curver 区分
	this.url_update = string.format("http://%s/api/version", host)			--三国英雄
	
	this.url_session = string.format("http://%s/user/verifySession", host)	--session验证地址: 
	this.url_servers = string.format("http://%s/api/server", host)			-- 服务器列表地址:channel 区分
	
	this.url_activity = string.format("http://%s/api/acty", host)			--列表地址: serverid 区分
	this.url_announcement = string.format("http://%s/api/note", host)		--公告地址: serverid 区分
	this.url_broadcast = string.format("http://%s/api/tip", host)			--广播: serverid 区分
	
	this.url_build_order = string.format("http://%s/pay/sub", host)			--生成订单
	this.url_iappurchase = string.format("http://%s/payaction/iosrecv", host)--ios 支付
	this.url_pay_syn = string.format("http://%s/payaction/yjrecv", host)	--(易接)通用支付回调
	this.url_bind_wechat = string.format("http://%s/user/verifyUid", host)
	this.url_user_login = string.format("http://%s/passport/login", host)	--玩家登陆
	this.url_register = string.format("http://%s/passport/reg", host)		--玩家注册
	this.url_change_passwd = string.format("http://%s/passport/changepd", host)--修改密码
	this.url_get_login_type= string.format("http://%s/api/logintype", host)
end



function PlatformMgr.addBlackList(newip, _type)
	local isExists = false
	
	for k, ip in pairs(this.blacklist[_type]) do
		isExists = (ip==newip)
		if isExists then break end
	end
	
	if isExists then
		this.blacklist[_type] = {}
	else
		table.insert(this.blacklist[_type], 1, newip)
	end
	
	return isExists
end

pcall(function() this.dhost = require("dhost") end)
--[[
	异步解析DNS
]]
function PlatformMgr.resolvesNameAsyn(domains, _type, listener)
	if this.asynHandle then return end
	
	local strBlack = ""
	
	if #this.blacklist[_type]>0 then
		strBlack = table.concat(this.blacklist[_type], ",")
	end
	
	this.dhost:dns2ipAsyn(domains, strBlack)
	
	local function update(dt)
		local newip, running = this.dhost:getNewIp()
		if running==0 and newip and string.len(newip)>0 then
			scheduler.unschedule(this.asynHandle)
			this.asynHandle = nil
			
			print("mir_debug:===resolves domains name asyn==>", newip)
			this.addBlackList(newip, _type)
			
			if listener then
				listener(newip)
			end
		end
	end
	
	this.asynHandle = scheduler.schedule(update, 0, false)
end

--[[
	同步解析DNS
]]
function PlatformMgr.resolvesName(domains, _type)
	--获取服务器列表后,访问的游戏服域名与http域名相同,则不需要二次DNS解析
	if domains==this.http_domains and _type=="gameserver" and #this.blacklist["httpserver"]==1 then
		local hostip = this.blacklist["httpserver"][1]
		this.addBlackList(hostip, "gameserver")
		return hostip
	end

	local strBlack = ""
	if #this.blacklist[_type]>0 then
		strBlack = table.concat(this.blacklist[_type], ",")
	end
	
	local newip = this.dhost:dns2ip(domains, strBlack)
	print("mir_debug:===resolves domains name syn==>", newip)
	
	if newip==nil or newip=="" then
		return domains
	end
	
	this.addBlackList(newip, _type)
	
	return newip
end

function PlatformMgr.switchHost()
	
	local newip = this.resolvesName(this.http_domains, "httpserver")
	this.setWebUrl(newip)
	
end

--[[
	是否appstore渠道
]]
function PlatformMgr.isAppStore()
	return (ChannelUserInfo:Get("pid")==6600)
end

--[[
	是否调试:
	1-android/ios没有调试模式;
	2-windows 要求isAppStore()==false 时才允许调试模式(该模式会不断的创建新号)
]]
function PlatformMgr.isDebugPlatform()
	if(this.isAppStore()==false and device.platform=="windows") then
		return true
	end
	
	return false
end

function PlatformMgr.isNetworkEnabled()
	if this.network>0 then
		return true
	else
		GameFunc.PerformWithDelay(0.16, function()
			this.checkNetwork()
		end)
	end
	
	return false
end

function PlatformMgr.getNetworkType()
	return this.network
end

function PlatformMgr.getBattery()
	return this.batterPercent
end

function PlatformMgr.isAppInBackground()
	return this.isAppEnterBackground
end

--[[
	新版本app需要删除本地的就更新数据
	玩家启动游戏时对比 xmlVersionCode (Xml记录的app version code) 和 curVersionCode(从app读取的version code)对比
	如果 xmlVersionCode<curVersionCode,则表示玩家刚安装新版的App，需要删除本地旧的更新目录
]]
function PlatformMgr.checkRemoveUpdate()
	local function removedir(path)
		if device.platform == "windows" then
			return os.execute("rd /s /q ".. string.gsub(path, '/', '\\'))
		else
			return os.execute("rm -rf " .. path)
		end
	end
	
	local userDefault = CCUserDefault:sharedUserDefault()
	local xmlVersionCode = userDefault:getStringForKey("AppVersionCode", "")
	
	xpcall(function()
		local curVersionCode = this.getVersionCode()
		
		if tostring(curVersionCode)==tostring(xmlVersionCode) then
			return
		end
		
		--1.写入本地版本号
		userDefault:setStringForKey("AppVersionCode", tostring(curVersionCode))
		userDefault:flush()
		
		--2.旧包-未曾记录过版本信息,返回,不让玩家删除重新下载
		if xmlVersionCode==nil or string.trim(xmlVersionCode)=="" or xmlVersionCode=="nil" then
			return
		end
		
		--3.对比是否安装新版app
		local isNewVerApp = this.isAppUpdate(curVersionCode, curVersionCode, xmlVersionCode)
		
		--4.删除更新目录
		if isNewVerApp then
			local ret1 = removedir(device.writablePath.."res/")
			local ret2 = removedir(device.writablePath.."scripts/")
			
			ReloadLuaFile()
			
			userDefault:setStringForKey("version", "")
			userDefault:flush()
			
			-- LoginNet.setVersionUrl() --重新设置版本检查的参数
		end
	end, function(err)
		--5.以上代码执行出错,重置本地版本号
		userDefault:setStringForKey("AppVersionCode", tostring(xmlVersionCode))
		userDefault:flush()
		__G__TRACKBACK__(err)
	end)
end

--[[
	检查app是否需要更新(currentVersion>localVersion)
	androidVer 当前的android版本号
	iosVersion 当前的ios版本号
	localVersion 本地版本号
]]
function PlatformMgr.isAppUpdate(androidVer, iosVersion, localVersion)
	local versionCode = this.getVersionCode()--app 版本号(ios-buildid, android-versionCode)
	local isUpdateApp = false
	
	if localVersion then
		versionCode = localVersion
	end
	
	if device.platform=="android" then
		if androidVer==nil or string.trim(androidVer)=="" then return false end
		isUpdateApp = ( tonumber(androidVer)>tonumber(versionCode) )
	elseif device.platform=="ios" then
		if not iosVersion or string.trim(iosVersion)=="" then return false end
		
		local tMinVer = string.split(iosVersion, ".")
		local tCurVer = string.split(versionCode, ".")
		
		for i=1, #tMinVer do --对比每一个版号的数值大小
			if not tCurVer[i] then tCurVer[i] = 0 end --客户端某一位的版号缺失，默认为0 (如：1.2)填写错误不规范的情况
			
			if tCurVer[i] and tonumber(tMinVer[i])>tonumber(tCurVer[i]) then --当前版本小于最低要求，更新
				isUpdateApp = true
				break
			elseif tCurVer[i] and tonumber(tMinVer[i])<tonumber(tCurVer[i]) then --当前版本大于最低要求，不需要更新
				break
			end
		end
	elseif device.platform=="windows" then
		if androidVer==nil or string.trim(androidVer)=="" then return false end
		isUpdateApp = ( tonumber(androidVer)>tonumber(versionCode) )
	end
	
	return isUpdateApp
end

--[[
	检查手机的网络类型
]]
function PlatformMgr.checkNetwork()
	if device.platform == "windows" then
		this.network = 1
	elseif device.platform == "ios" then
		CCPlatformMgr:getInstance():initNetwork()
	elseif device.platform == "android" then
		-- call Java method
		local javaClassName = "com/common/mir/MirNative"
		local javaMethodName = "getNetworkType"
		local javaParams = {}
		local javaMethodSig = "()I"
		
		 -- ok: 是否调用成功; ret: 调用成功后java的返回值
		local ok, ret = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
		
		if ok then
			this.network = tonumber(ret)
		end
	end
end


--[[
	android 小提示窗口
	@param text 显示文本
	@param duration 0-短时显示, 1-长时显示
]]
function PlatformMgr.makeToast(text, duration)
	if text==nil or text=="" then
		return
	end
	
	if duration==nil or duration~=0 then
		duration = 1
	end
	
	if device.platform=="android" then
		local javaClassName = "com/common/mir/MirNative"
		local javaMethodName = "makeToast"
		local javaParams = {text, duration}
		local javaMethodSig = "(Ljava/lang/String;I)V"
		local ok = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)	
	else
		local runningScene = display.getRunningScene()
		if runningScene then
			runningScene:addChild(UINotice.new(text), 1000)
		end
	end
end

--[[
	重启游戏
]]
function PlatformMgr.restartGame()
	if device.platform=="android" then
		-- call Java method
		local javaClassName = "com/common/mir/MirNative"
		local javaMethodName = "restartGame"
		local javaParams = {}
		local javaMethodSig = "()V"
	
		local ret = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
	else
		CCDirector:sharedDirector():endToLua()
	end
end

--[[
	获取手机型号
]]
function PlatformMgr.getPhoneModel()
	if device.platform=="android" then
		if this.phoneModel== "windows" then
			-- call Java method
			local javaClassName = "com/common/mir/MirNative"
			local javaMethodName = "getPhoneModel"
			local javaParams = {}
			local javaMethodSig = "()Ljava/lang/String;"
		
			local ret, model = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
			this.phoneModel = model
		end
	elseif device.platform=="ios" then
		this.phoneModel = CCPlatformMgr:getInstance():getPhoneModel()
	end
	
	return this.phoneModel
end

--[[
	获取设备id
]]
function PlatformMgr.getDeviceId()
	if device.platform=="android" then
		if this.phoneModel== "windows" then
			-- call Java method
			local javaClassName = "com/common/mir/MirNative"
			local javaMethodName = "getIMEI"
			local javaParams = {}
			local javaMethodSig = "()Ljava/lang/String;"
		
			local ret, imei = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
			if ret then this.deviceId = imei end
		end
	elseif device.platform=="ios" then
		this.deviceId = CCPlatformMgr:getInstance():getDeviceId()
	end
	
	return this.deviceId
end

--[[
	android 小提示窗口
	@param url 网页地址
]]
function PlatformMgr.getVersionCode()
	if this.appVersion then return this.appVersion end
	
	xpcall(function()
		if device.platform=="android" then
			-- call Java method
			local javaClassName = "com/common/mir/MirNative"
			local javaMethodName = "getVersionCode"
			local javaParams = {}
			local javaMethodSig = "()I"
			local ok, ret = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)	
			
			if ok then this.appVersion = ret end
		elseif device.platform=="ios" then
			this.appVersion = CCPlatformMgr:getInstance():getVersionCode()
		end
	end, function(err)end)
	
	if this.appVersion then return this.appVersion end
	
	return 1
end


function PlatformMgr.doVibrate(milliseconds)
	
	device.vibrate(milliseconds)

	-- if device.platform=="android" then
		-- local javaClassName = "com/common/mir/MirNative"
		-- local javaMethodName = "doVibrate"
		-- local javaParams = {milliseconds}
		-- local javaMethodSig = "(I)V"
	
		-- local ret = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
		
	-- elseif device.platform=="windows" then
		
	-- end
end

function PlatformMgr.getIMSI()
	if device.platform=="android" then
		-- call Java method
		local javaClassName = "com/common/mir/MirNative"
		local javaMethodName = "getIMSI"
		local javaParams = {}
		local javaMethodSig = "()Ljava/lang/String;"
	
		local ok, result = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
		if ok then return result end
	end
	
	return ""
end

function PlatformMgr.getCpuInfo()
	if device.platform=="android" then
		-- call Java method
		local javaClassName = "com/common/mir/MirNative"
		local javaMethodName = "getCpuInfo"
		local javaParams = {}
		local javaMethodSig = "()Ljava/lang/String;"
	
		local ok, result = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
		if ok then return result end
	end
	
	return ""
end

function PlatformMgr.isFileExists(paths)
	local jsonPaths = json.encode(paths)
	
	if device.platform=="android" then
		-- call Java method
		local javaClassName = "com/common/mir/MirNative"
		local javaMethodName = "isFileExists"
		local javaParams = {jsonPaths}
		local javaMethodSig = "(Ljava/lang/String;)I"
	
		local ok, result = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
		if ok then return result==1 end
	end
	
	return false
end

function PlatformMgr.getMacAddress()
	if device.platform=="android" then
		-- call Java method
		local javaClassName = "com/common/mir/MirNative"
		local javaMethodName = "getMacAddress"
		local javaParams = {}
		local javaMethodSig = "()Ljava/lang/String;"
	
		local ok, result = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
		if ok then return result end
	end
	
	return ""
end

function PlatformMgr.getSystemProperty(name)
	if device.platform=="android" then
		-- call Java method
		local javaClassName = "com/common/mir/MirNative"
		local javaMethodName = "getSystemProperty"
		local javaParams = {name}
		local javaMethodSig = "(Ljava/lang/String;)Ljava/lang/String;"
	
		local ok, result = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
		if ok then return result end
	end
	
	return ""
end

--[[
	判断是否是模拟器
]]
function PlatformMgr.isSimulator()
	if device.platform=="windows" or device.platform=="ios" then
		return false
	end
	
	-- local imei = device.getOpenUDID()
	local imei = this.getDeviceId()
	local imsi = this.getIMSI()
	local icpu = this.getCpuInfo()
	local model= this.getPhoneModel()
	
	local macAddresss = this.getMacAddress()
	
	local bluestacks = {
		"/data/app/com.bluestacks.appmart-1.apk", "/data/app/com.bluestacks.BstCommandProcessor-1.apk",  
		"/data/app/com.bluestacks.help-1.apk", "/data/app/com.bluestacks.home-1.apk", "/data/app/com.bluestacks.s2p-1.apk",  
		"/data/app/com.bluestacks.searchapp-1.apk", "/data/bluestacks.prop", "/data/data/com.androVM.vmconfig",  
		"/data/data/com.bluestacks.accelerometerui", "/data/data/com.bluestacks.appfinder", "/data/data/com.bluestacks.appmart",  
		"/data/data/com.bluestacks.appsettings", "/data/data/com.bluestacks.BstCommandProcessor", "/data/data/com.bluestacks.bstfolder",  
		"/data/data/com.bluestacks.help", "/data/data/com.bluestacks.home", "/data/data/com.bluestacks.s2p", "/data/data/com.bluestacks.searchapp",  
		"/data/data/com.bluestacks.settings", "/data/data/com.bluestacks.setup", "/data/data/com.bluestacks.spotlight", "/mnt/prebundledapps/bluestacks.prop.orig"
	}
	local isExists = PlatformMgr.isFileExists(bluestacks)
	
	
	local function isFileExists(path)
		local file = io.open(path, "rb")
		if file then
			file:close()
			return true
		end
		
		return false
	end
	
	--模拟器特有文件,真机没有
	local b1 = isFileExists("/dev/socket/qemud")
	local b2 = isFileExists("/dev/qemu_pipe")
	local b3 = PlatformMgr.isFileExists({"/dev/socket/qemud", "/dev/qemu_pipe", ""})
	
	--result.contains("arm") result.contains("intel") result.contains("amd")
	-- icpu = string.sub(icpu, 1, 256)
	
	-- local str1 = PlatformMgr.getSystemProperty("ro.hardware")
	-- local str2 = PlatformMgr.getSystemProperty("ro.kernel.qemu")
	-- local str3 = PlatformMgr.getSystemProperty("ro.product.model")
	
	local t = {icpu}
	local info = table.concat(t, "# ")
	
	local lblInfo = ui.newTTFLabel({text=info, size=22, font=G_FONT_NAMES.HeiTi, dimensions=CCSize(600, 0) })
	lblInfo:setPosition(visibleSize.width/2, visibleSize.height/2)
	GameLayerMgr.getMainLayer():addChild(lblInfo, 200)
	
	return false
end



--[[
	获取输入框高度
]]
function PlatformMgr.getInputHeight()
	
end

function PlatformMgr.exitGame()
	
	if device.platform == "windows" or device.platform == "ios" then
		CCDirector:sharedDirector():endToLua()
	elseif device.platform == "android" then
		-- call Java method
		local javaClassName = "com/common/mir/MirNative"
		local javaMethodName = "exitGame"
		local javaParams = {}
		local javaMethodSig = "()V"
		
		 -- ok: 是否调用成功; ret: 调用成功后java的返回值
		local ok, ret = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
		
	end
end

--[[
	通知android 游戏启动初始化完毕
]]
function PlatformMgr.gameInitEnd()
	if device.platform == "windows" then
		
	elseif device.platform == "android" then
		-- call Java method
		local javaClassName = "com/common/mir/MirNative"
		local javaMethodName = "gameInitEnd"
		local javaParams = {}
		local javaMethodSig = "()V"
		
		 -- ok: 是否调用成功; ret: 调用成功后java的返回值
		local ok, ret = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
		
	elseif device.platform == "ios" then
		CCPlatformMgr:getInstance():gameInitEnd()
	end
end


--[[
	提交玩家的额外信息：登陆、升级时处理
]]
function PlatformMgr.submitExtralInfo(tParam)
	local jsonParam = json.encode(tParam)
	
	if device.platform == "windows" then
		
	elseif device.platform == "android" then
		-- call Java method
		local javaClassName = "com/common/mir/MirNative"
		local javaMethodName = "setExtralInfo"
		local javaParams = {jsonParam}
		local javaMethodSig = "(Ljava/lang/String;)V"
	
		local bool, resultStr = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
	elseif device.platform == "ios" then
		CCPlatformMgr:getInstance():setExtraInfo(jsonParam)
	end
end

function PlatformMgr.enterUserCenter()
	if device.platform == "ios" then
		CCPlatformMgr:getInstance():enterUserCenter()
	end
end

function PlatformMgr.enterCustomerCenter()
	if device.platform == "ios" then
		CCPlatformMgr:getInstance():enterCustomerCenter()
	end
end

function PlatformMgr.enterBBS()
	if device.platform == "ios" then
		CCPlatformMgr:getInstance():enterBBS()
	end
end

function PlatformMgr.showToolBar(place)
	if device.platform == "ios" then
		CCPlatformMgr:getInstance():showToolBar(place)
	end
end

function PlatformMgr.hideToolBar()
	if device.platform == "ios" then
		CCPlatformMgr:getInstance():hideToolBar()
	end
end

--[[
	手机是否有本地的游客账号
]]
function PlatformMgr.hasLocalGuestAccount()
	if device.platform == "windows" then
		
	elseif device.platform == "android" then
		
	elseif device.platform == "ios" then
		return CCPlatformMgr:getInstance():hasLocalGuestAccount()
	end
	
	return false
end

--[[
	手机是否安装有微信
]]
function PlatformMgr.isWeChatInstalled()
	if device.platform == "windows" then
		
	elseif device.platform == "android" then
		
	elseif device.platform == "ios" then
		-- return CCPlatformMgr:getInstance():isWeChatInstalled()
	end
	
	return true
end

--[[
	调用微信登录:IOS接口实现, Android未实现
]]
function PlatformMgr.handleWeChatLogin()
	CCPlatformMgr:getInstance():handleWeChatLogin()
end

--[[
	删除本地游客账号:IOS接口实现, Android未实现
]]
function PlatformMgr.clearLocalGuest()
	CCPlatformMgr:getInstance():clearLocalGuest()
end

--[[
	获取剪切板复制的内容
]]
function PlatformMgr.getPastStr()
	if device.platform == "android" then
		-- call Java method
		local javaClassName = "com/common/mir/MirNative"
		local javaMethodName = "GetPastStr"
		local javaParams = {}
		local javaMethodSig = "()V"
	
		local bool, resultStr = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
	elseif device.platform == "ios" then
		local text = CCPlatformMgr:getInstance():getPasteStr()
		SetPasteText(text)
	end
end

--[[
	打开跳转到网络设置的提示框：Android有效
]]
function PlatformMgr.openNetworkAlert()
	if device.platform~="android" or PlatformMgr.isOpenAlert then
		return
	end
	
	PlatformMgr.isOpenAlert = true
	
	-- call Java method
	local javaClassName = "com/common/mir/MirNative"
	local javaMethodName = "openNetworkAlert"
	local javaParams = {function() PlatformMgr.isOpenAlert = false end}
	local javaMethodSig = "(I)V"
	local ok = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
	
end

--[[
	Sdk登录
]]
function PlatformMgr.sdkLogin()
	if device.platform=="android" then
		-- call Java method
		local javaClassName = "com/common/mir/MirNative"
		local javaMethodName = "sdkLogin"
		local javaParams = {1}
		local javaMethodSig = "(I)V"
	
		local ret = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
	elseif device.platform=="ios" then
		CCPlatformMgr:getInstance():doSdkLogin()
	end
end

--[[
	调用sdk支付
]]
function PlatformMgr.handleSdkPay(jsonParam)
	if device.platform == "windows" then
		
	elseif device.platform == "android" then
		-- call Java method
		local javaClassName = "com/common/mir/MirNative"
		local javaMethodName = "sdkPay"
		local javaParams = {jsonParam}
		local javaMethodSig = "(Ljava/lang/String;)V"
	
		local bool, resultStr = luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
	elseif device.platform=="ios" then
		CCPlatformMgr:getInstance():handleSdkPay(jsonParam)
	end
end

--[[
	@desc 获取登陆需要的uid和token参数，正式平台和调试平台返回的数据有差别
	@param isCreateRole 是否是创建角色时调用(rolelogin)
	@return uid, token
]]
function PlatformMgr.getLoginInfo(isCreateRole)
	local uid = ChannelUserInfo:Get("uid")
	local token = ChannelUserInfo:Get("session")
	
	if this.isDebugPlatform() then
		token = "-1"
		uid = os.time()
		if isCreateRole then uid="-1" end --"-1" "7712870" 调试平台创建角色uid固定-1
	end
	
	return uid, token
end

--[[
	请求充值订单Id，cocos2d-x Http
]]
function PlatformMgr.reqBuildOrderId(productId)
	print("mir_debug:------------recharge_id=", productId)
	local serverid	= LoginNet.G_LOGIN_SERVER_ID
	local roleid	= LoginNet.G_LOGIN_ROLE_ID
	local userid	= ChannelUserInfo:Get("uid")
	local channel	= ChannelUserInfo:Get("pid")
	
	local luaRecharge = r_recharge[productId]
	
	local price		= luaRecharge["recharge_money"]
	local gold		= GamePlayer:Get("gold")
	local level		= GamePlayer:Get("level")
	local vipLevel	= GamePlayer:Get("viplevel")
	local roleName	= GamePlayer:Get("role_name")
	local groupName = GamePlayer:Get("group_name")
	local serverName= LoginNet.ServerSet[serverid]["server_name"]
	
	local uiLayer	= GameLayerMgr.getMainLayer()
	local uiLoading = LoadingLayer.new({loading_time=10, cmd_name="build_order", is_visible=true});
	uiLoading:setTag(SCENE_LAYER_TAG_LOADING)
	uiLayer:addChild(uiLoading, 9)
	
	local function onOrderEvent(event)
		local request = event.request
		local isError = false
		
		if event.name=="completed" then
			if request:getResponseStatusCode()==200 then				
				local t = LoginNet.json2lua(request:getResponseString())
				print_r(t)
				
				if t and t["errno"]==1 then
					local orderId, errMsg = t["order_id"], t["errmsg"]--, t["extension"]
					
					--扩展字段，服务器需要的参数
					local strExtesion = string.format("%d_%d_%s", roleid, serverid, orderId)
					
					local goodsNumb = 1
					local goodsName = luaRecharge["recharge_name"]
					
					if this.getChannel()==6601 then--QuickSDK
						if luaRecharge["recharge_type"]~=2 then
							goodsName = "元宝"
							goodsNumb = luaRecharge["recharge_gold"]
						end
					end
					
					--其他商品id
					local tProduct = {}
					for k, v in pairs(r_recharge) do
						if k~=productId then
							table.insert(tProduct, k)
						end
					end
					
					local products = table.concat(tProduct, ",") --苹果购买要把所有的计费点都提交
					
					-- print("--------------->products=>", products)
					
					local payType = 1
					local paySynUrl = PlatformMgr.url_pay_syn
					if this.isAppStore() then --ios 要判断支付方式
						payType = LoginNet.G_PAY_TYPE
						if payType==1 then
							paySynUrl = PlatformMgr.url_iappurchase --苹果支付回调
						end
					end
					
					--table key值与java的订单类字段名一致
					local luaParams = {money=price, balance=gold, orderId=orderId, goods=goodsName, roleId=roleid, roleName=roleName, 
						roleLv=level, vipLv=vipLevel, partyName=groupName, serverId=serverid, buyIndex=productId, payType=payType,
						serverName=serverName, extension=strExtesion, buyNum=goodsNumb, otherProducts=products, paySyncUrl=paySynUrl}
					
					local jsonParam = json.encode(luaParams)
					
					--SDK Pay
					PlatformMgr.handleSdkPay(jsonParam)
					
					GameFunc.PerformWithDelay(10, function()
						if uiLayer then uiLayer:removeChildByTag(SCENE_LAYER_TAG_LOADING) end
					end)
				else
					isError = true
				end
			else
				isError = true
			end
		elseif event.name=="inprogress" or event.name=="progress" then
		else
			isError = true
		end
		
		if isError then
			if uiLoading then uiLoading:removeFromParent() end
			
			uiLayer:addChild(UINotice.new(GString["BuildOrderErr"]), 10)
		end
	end
	
	-- http://xxx/pay/sub?pid=xxx&uid=xxx&role_id=xxx&server_id=xxx&product_id=xxx&price=xxx
	
	local strParams = string.format("pid=%d&uid=%s&role_id=%d&server_id=%d&product_id=%d&price=%d&product_name=%s&product_desc=%s",
		channel, userid, roleid, serverid, productId, price*100, string.urlencode(luaRecharge["recharge_name"]), "")--string.urlencode(luaRecharge["recharge_desc"])
	
	local strUrl = string.format("%s?%s", PlatformMgr.url_build_order, strParams)
    local request = CCHTTPRequest:createWithUrl(
		onOrderEvent,
        strUrl,	--获取充值订单号
        kCCHTTPRequestMethodGET)
    request:setTimeout(6)
    request:start()
end



--[[
	处理支付结果相关
]]
this.scheduler = CCDirector:sharedDirector():getScheduler()
function PlatformMgr.unRegisterPay()
	if this.payHandler then
		this.scheduler:unscheduleScriptEntry(this.payHandler)
	end
	this.payHandler = nil
	this.isOnPayReq = false
end

--[[
	弹出服务端返回的支付结果窗口
]]
function PlatformMgr.uiAlertSvrPay()
	if this.tServerOrders==nil or #this.tServerOrders==0 then
		return
	end
	
	local svrOrder = table.remove(this.tServerOrders, 1)
	
	table.insert(this.tTempSvrOrder, svrOrder) --临时保存
	
	local luaRecharge = r_recharge[svrOrder.productid]
	local productName = (luaRecharge) and luaRecharge["recharge_name"] or "?"
	
	local uiMainLayer= GameLayerMgr.getMainLayer()
	local touchGroup = TouchGroup:create()
	-- touchGroup:setTouchSwallowEnabled(false)
	uiMainLayer:addChild(touchGroup, 99)
	
	local uiPanel = GUIReader:shareReader():widgetFromJsonFile("ui/Layout_Dialog2.json")
	local uiSize  = uiPanel:getSize()
	
	local posx, posy = (visibleSize.width-uiSize.width)/2, (visibleSize.height-uiSize.height)/2
	
	--设置touchGroup的触摸区域为对话框范围，该范围内触摸不穿透
	-- touchGroup:setTouchRect(CCRect(posx, posy, uiSize.width, uiSize.height))
	
	uiPanel:setPosition(ccp( posx, posy ))
	touchGroup:addWidget(uiPanel)
	
	local uiBgImg = touchGroup:getWidgetByName("Img_Bg")
	local uiBtnOk = touchGroup:getWidgetByName("Btn_Opt")
	
	uiBtnOk:setTitleText(GString["SureText"])
	
	--支付成功/失败提示
	local bgSize= uiBgImg:getSize()
	local text1 = string.format(GString["PaySuccessFmt"], productName)
	local fontColor = ccc3(255, 255, 255)
	local lblSize = CCSize(332, 0)
	
	if svrOrder["ordererr"]=="0" then--成功订单
		if luaRecharge["recharge_type"]==2 then --购买月卡
			NetUnit.SendRequest("mcardinfo", {role_id=LoginNet.G_LOGIN_ROLE_ID}, 0, true, function(data)
				GameMonthCardList:Convert(data)
			end, true)
		end
	else
		fontColor = G_COLORS[30]
		text1 = string.format(GString["PayFailFmt"], productName, svrOrder["ordererr"])
	end
	
	local text2 = string.format("%s:%s", GString["OrderNo"], svrOrder["orderid"])
	
	local uiText, uiHeight1 = UIPublic.CreateUIRichText2({{text=text1, color=fontColor}}, lblSize, 22, 2)
	local uiOrder,uiHeight2 = UIPublic.CreateUIRichText2({{text=text2, color=ccc3(255, 255, 255)}}, lblSize, 20, 2)
	
	uiText:setPosition(ccp(0, bgSize.height/2-6))
	uiOrder:setPosition(ccp(0, bgSize.height/2-6-uiHeight1-6))
	uiBgImg:addChild(uiText)
	uiBgImg:addChild(uiOrder)
	
	uiBtnOk:addTouchEventListener(function(sender, evtype)
		touchGroup:removeFromParent()
		
		GameFunc.PerformWithDelay(0.1, function()
			this.uiAlertSvrPay()
		end)
	end) 
end

--[[
	弹出客户端获取支付结果失败的窗口
]]
function PlatformMgr.uiAlertCliPay()
	if this.tClientOrders==nil then
		return
	end
	
	local cpOrderNo = ""
	for orderId, value in pairs(this.tClientOrders) do
		if value==0 then
			this.tClientOrders[orderId] = nil
			cpOrderNo = orderId
			break
		end
	end
	
	if cpOrderNo=="" then
		return
	end
	
	--已经提前收到了支付结果
	for k, v in pairs(this.tTempSvrOrder) do
		if v and v.orderid==cpOrderNo and v.ordererr=="0" then
			return
		end
	end
	
	
	
	local uiMainLayer= GameLayerMgr.getMainLayer()
	local touchGroup = TouchGroup:create()
	-- touchGroup:setTouchSwallowEnabled(false)
	uiMainLayer:addChild(touchGroup, 99)
	
	local uiPanel = GUIReader:shareReader():widgetFromJsonFile("ui/Layout_Dialog2.json")
	local uiSize  = uiPanel:getSize()
	
	local posx, posy = (visibleSize.width-uiSize.width)/2, (visibleSize.height-uiSize.height)/2
	
	uiPanel:setPosition(ccp( posx, posy ))
	touchGroup:addWidget(uiPanel)
	
	local uiBgImg = touchGroup:getWidgetByName("Img_Bg")
	local uiBtnOk = touchGroup:getWidgetByName("Btn_Opt")
	
	uiBtnOk:setTitleText(GString["SureText"])
	
	--支付成功/失败提示
	local bgSize  = uiBgImg:getSize()
	local lblSize = CCSize(320, 0)
	local fontColor = ccc3(255, 255, 255) --G_COLORS[30] --red
	local text1 = GString["GetPayResultFail"]..cpOrderNo
	
	local uiText, uiHeight = UIPublic.CreateUIRichText2({{text=text1, color=fontColor}}, lblSize, 22, 2)
	uiText:setPosition(ccp(0, bgSize.height/2-(bgSize.height-uiHeight)/2))
	uiBgImg:addChild(uiText)
	
	uiBtnOk:addTouchEventListener(function(sender, evtype)
		touchGroup:removeFromParent()
		
		GameFunc.PerformWithDelay(0.1, function()
			this.uiAlertCliPay()
		end)
	end)
end



--[[
	sdk端支付成功的回调
]]
function SdkRechargeSuccess(cpOrderNo)
	--缓存本地sdk支付成功的订单
	PlatformMgr.tClientOrders[cpOrderNo] = 0
	
	PlatformMgr.handlePayResult(false)
	
	--向GM服通知sdk支付成功
	
end

--[[
	Android通知支付结果
]]
function PlatformMgr.handlePayResult(isForceReq)
	if this.isOnPayReq and isForceReq then--心跳通知时，刚好定时器在请求了，return
		return
	end
	
	--新的支付结果处理，先把原有的定时器删除
	this.unRegisterPay()
	
	local tIntervals = {2, 2, 2, 2, 2, 3, 3, 4, 5}--间隔时间请求支付结果
	local _time = 0
	local reqCount = 1
	
	local function onPayMessage(data)
		this.isOnPayReq = false
		
		-- print("mir_debug----------recharge data----------")
		-- print_r(data)
		if data==nil then return end
		
		if data["errno"]==0 then
			if data["orders"] and #data["orders"]>0 then
				this.unRegisterPay()
				
				for k, order in pairs(data["orders"]) do
					table.insert(this.tServerOrders, order)
					--判定服务端成功处理的客户端支付的订单，成功则把客户端对应订单标识为 1
					if order.ordererr=="0" and this.tClientOrders[order.orderid] then
						this.tClientOrders[order.orderid] = 1
						
						local gRecharge = GameRechargeList:Get(order.productid)
						if gRecharge then
							gRecharge:Set("orderts", order.orderts)
						end
					end
				end
				
				this.uiAlertSvrPay() --弹出支付结果窗口
			end
			
			GamePlayer:Set("gold", data["gold"])
			GamePlayer:Set("rmb",  data["rmb"]) --累计充值rmb
			GamePlayer:Set("vipexp",  data["vipexp"])
			GamePlayer:Set("viplevel", data["viplevel"])
			GamePlayer:Set("first", data["first"])	--首冲是否已领取
			
			CCNotificationCenter:sharedNotificationCenter():postNotification(G_NF_SHOW_HIDE_MAIN_TOP_MENU, CCBool:create(true))
			CCNotificationCenter:sharedNotificationCenter():postNotification(G_NF_UPDATE_UI_MAIN_DATA)
		elseif data["errno"]==1 then--roleid 不存在
			
		end
	end
	
	local function update(dt)
		_time = _time + dt
		
		if this.isOnPayReq then --正在请求支付结果
			if _time<6 then
				do return end
			else	--chkrecharge发送6s收不到回复(超时)，进入下一个 tIntervals
				_time = tIntervals[reqCount]
			end
		end
		
		local interval = tIntervals[reqCount]
		
		if not interval then
			this.unRegisterPay()
			
			--弹出获取支付结果失败提示
			PlatformMgr.uiAlertCliPay()
			
		elseif _time>=interval then
			_time = 0
			reqCount = reqCount + 1
			this.isOnPayReq = true
			NetUnit.SendRequest("chkrecharge", {role_id = LoginNet.G_LOGIN_ROLE_ID}, 0, true, onPayMessage, true)
		end
	end
	
	if isForceReq then --心跳通知说有订单通知，直接请求
		_time = tIntervals[1]
	end
	
	this.payHandler = this.scheduler:scheduleScriptFunc(update, 0.25, false)
	
end



---------------------------android/ios 调用的lua全局函数------------------------------
--[[
	android 返回键弹出退出游戏框
]]
function ExitGameListen()
	local uiDialog = UIDialog2.new({text=G_STRING["ExitGame"]})
	uiDialog:setBtnCallback(function(layer, button)
		PlatformMgr.exitGame()
	end)
	
	GameLayerMgr.getMainLayer():addChild(uiDialog, 1000)
end

--[[
	Android通知粘贴剪贴板内容
]]
function SetPasteText(text)
	CCNotificationCenter:sharedNotificationCenter():postNotification(G_NF_PASTE_NOTICE, CCString:create(text))
end

--[[
	android 通知网络变化
	strdata = networktype_status
]]
function NotifyNetChange(strdata)
	if not strdata then return end
	local t = string.split(strdata, "_")
	if t and t[1] then
		if tonumber(t[1])>0 and tonumber(t[1])~=PlatformMgr.network then
			 GameFunc.PerformWithDelay(0.6, function()
				local roleId = LoginNet.G_LOGIN_ROLE_ID
				if roleId and roleId>0 and device.platform=="ios" then --强制重连
					Network.offlineConnect("", true)
				end
			 end)
		end
		PlatformMgr.network = tonumber(t[1])
	end
end

local ccCenter = CCNotificationCenter:sharedNotificationCenter()

--[[
	android 通知电量变化
	percent 电量百分比值
]]
function NotifyBatteryChange(percent)
	local p = tonumber(percent)
	PlatformMgr.batterPercent = p
	if PlatformMgr.isAppEnterBackground() then
		-- GameFunc.PerformWithDelay(0.3, function()
			-- ccCenter:postNotification(G_NF_BATTERY_CHANGE, CCInteger:create(PlatformMgr.batterPercent))
		-- end)
	else
		-- ccCenter:postNotification(G_NF_BATTERY_CHANGE, CCInteger:create(PlatformMgr.batterPercent))
	end
end

--[[
	android 通知信号强度变化
	strength 对应显示几格信号
]]
function NotifySignalChange(strength)
	if not strength then
		strength = 0
	end
	
	-- ccCenter:postNotification(G_NF_SIGNAL_CHANGE, CCInteger:create(strength))
end

--[[
	Android通知SDK登陆成功
	@param text (session#autoVerifySession#uid)
	
	传入参数：
	用户sessionID：	session
	用户ID：		uid
	渠道ID：		pid
	时间戳：		time
	签名：			sign = md5(session+uid+pid+time+'#'+key)
]]
function SdkLoginSuccess(jsonResult)
	-- local strlist = string.split(text, "#")
	-- local session, isVerify, uid = strlist[1], strlist[2], strlist[3]
	
	local tLogin = json.decode(jsonResult)
	if tLogin and tLogin.sdkUId then
		ChannelUserInfo:Set("uid", tLogin.sdkUId)
		ChannelUserInfo:Set("session", tLogin.session)
		
		local appId = tLogin.appId
		local channelId = tLogin.channelId
		
		if appId then
			appId = string.gsub(appId, "{", "")
			appId = string.gsub(appId, "}", "")
			appId = string.gsub(appId, "-", "")
		end
		if channelId then
			channelId = string.gsub(channelId, "{", "")
			channelId = string.gsub(channelId, "}", "")
			channelId = string.gsub(channelId, "-", "")
		end
		
		ChannelUserInfo:Set("appId", appId)
		ChannelUserInfo:Set("channelId", channelId)--(易接|QuickSDK平台标示的渠道SDK ID)
		
		print("mir_debug=======login success===", jsonResult)
		LoginNet.verifySdkSession(1)
	else
		PlatformMgr.makeToast("登录结果错误！")
	end
end

--[[
	微信登录结果
]]
function OnWeChatLogin(jsonResult)
	local tlogin = json.decode(jsonResult)
	
	if tlogin and tlogin.session then
		CCNotificationCenter:sharedNotificationCenter():postNotification(G_NF_WECHAT_LOGIN_SUCCESS, CCString:create(tlogin.session))
	else
		GameLayerMgr.uiShowNotice(GString["WxLoginError"], 5000)
	end
end


function SdkLoginFail()--IOS 登录
	GameLayerMgr.uiShowNotice(GString["LoginErr2"], 10)
end

function SdkLogout()
	LoginNet.G_LOGIN_ROLE_ID = 0
	LoginNet.G_LOGIN_SERVER_ID = 0
	LoginNet.ResetFlag()
	LoginNet.ServerClean()
	GameLayerMgr.allClear()
	Network.dataReset()
	SwitchAccountAndCleanData()
	LoginNet.G_IS_LOGIN = true
	LoginScene.create(true)
	
end

--[[
	IOS 移除登录的loading
]]
function LoginRemoveLoading()
	GameFunc.PerformWithDelay(0.24, function()
		GameLayerMgr.getMainLayer():removeChildByTag(SCENE_LAYER_TAG_LOADING)
	end)
end

--[[
	apple appstore 应用内购成功的receipt提交到服务端，由服务端想appstore验证
]]
function CommitAppStoreReceipt2Server(strReceipt, cpOrderNo)
	--[[
		21000 App Store不能读取你提供的JSON对象
		21002 receipt-data域的数据有问题
		21003 receipt无法通过验证
		21004 提供的shared secret不匹配你账号中的shared secret
		21005 receipt服务器当前不可用
		21006 receipt合法，但是订阅已过期。服务器接收到这个状态码时，receipt数据仍然会解码并一起发送
		21007 receipt是Sandbox receipt，但却发送至生产系统的验证服务
		21008 receipt是生产receipt，但却发送至Sandbox环境的验证服务
	]]
	local function handleIapError(errorcode)
		errorcode = tonumber(errorcode)
		local errorNotice = string.format("支付校验错误，错误号：%d", errorcode)
		
		if errorcode==20000 or errorcode==21000 or errorcode==21002 or errorcode==21003 or errorcode==21004 or errorcode==21005
			or errorcode==21006 or errorcode==21007 or errorcode==21008 then
			
		else
			errorNotice = "支付校验未知错误"
		end
		
		local orInfo = PlatformMgr.tIAPOrders[cpOrderNo]
		if not orInfo or orInfo.reqCount==1 then --只提示一次
			GameLayerMgr.uiShowNotice(errorNotice, 3000)
		end
	end
	
	
	--向GM服提交数据验证(http) ,保存receipt
	local function onHttpResponse(event)
		local request = event.request
		local tryAgain = false --重试
		--return: {"buy":"0"|"1" 服务器验证码:1-成功 0-错误 , "message":"", "status":2000 苹果验证错误码}
		if event.name=="completed" then
			if request:getResponseStatusCode()==200 then
				local t = LoginNet.json2lua(request:getResponseString())
				if t and (t.buy==1 or t.buy=="1") then
					--缓存本地sdk支付成功的订单
					PlatformMgr.tClientOrders[cpOrderNo] = 0
					PlatformMgr.handlePayResult(false)
					
					PlatformMgr.tIAPOrders[cpOrderNo] = nil
				else
					-- tryAgain = true
					local errorcode = 0
					if t then errorcode = t.status end
					handleIapError(errorcode)
					PlatformMgr.tIAPOrders[cpOrderNo] = nil
				end
			else
				tryAgain = true
			end
		elseif event.name=="inprogress" or event.name=="progress" then
		else
			tryAgain = true
		end
		
		local orInfo = PlatformMgr.tIAPOrders[cpOrderNo]
		if tryAgain and orInfo then
			orInfo.reqCount = orInfo.reqCount + 1
			if orInfo.reqCount<7 then
				GameFunc.PerformWithDelay(0.5, function() --
					CommitAppStoreReceipt2Server(orInfo.receipt, cpOrderNo)
				end)
			else
				PlatformMgr.tIAPOrders[cpOrderNo] = nil
			end
		end
	end
	
	PlatformMgr.tIAPOrders[cpOrderNo] = {receipt=strReceipt, reqCount=1}
	
	local postData = string.format("receipt=%s&cpOrder=%s", strReceipt, cpOrderNo)
	LoginNet.applyHttpRequest(PlatformMgr.url_iappurchase, 6, onHttpResponse, "post", postData) --iap内购向服务器提交验证
	
end


function AppDidEnterBackground()
	print("mir_debug:====AppDidEnterBackground====")
	this.isAppEnterBackground = true
	this.timstamp = os.time()
	
	SimpleAudioEngine:sharedEngine():pauseAllEffects()
	SimpleAudioEngine:sharedEngine():pauseBackgroundMusic()
end

function AppWillEnterForeground()
	print("mir_debug:====AppWillEnterForeground====")

	local isStop = GameAudioMgr.IsStopBackground()
	if not isStop then
		SimpleAudioEngine:sharedEngine():resumeBackgroundMusic()
	end
	isStop = GameAudioMgr.IsStopEffects()
	if not isStop then
    	SimpleAudioEngine:sharedEngine():resumeAllEffects()
	end

	if PlatformMgr.isPauseGuide then--引导暂停时不主动恢复游戏
		CCDirector:sharedDirector():pause()
	end
    
	local result = os.time()-this.timstamp>20 --超过20s才允许重连
	
	GameFunc.PerformWithDelay(1, function()
		if not LoginNet.G_IS_LOGIN then --非登陆界面，直接重连
			if result then Network.offlineConnect("", true) end
		else
			this.checkNetwork() --登录后从后台返回才允许检查网络
		end
		PlatformMgr.isAppEnterBackground = false--必须：延时1s后才允许网络连接，否则容易出现黑屏
	end)
end